----------------------------------------------------------------------------------
-- Company: Kanagawa Institute of Technology
-- Engineer: Takuya Katayama
--
-- ZIGZAGXLH(ZIGZAGSCAN_PROCESS.vhd)
-- Revision: 1.0
--
-- Revision 1.0 - 2010/04/13 łJ܂
--
-- memo
-- ̃W[8~8̗̈WOUO(WOUOe[u̒ʂ)XLAo͂铮s܂
-- X^[gtO1CLKẴ^C~OA64CLKĒl͂A1CLKԂuA܂64CLKĒlo͂܂B
--@(ɂ́AX^[gtO͐CLKĂĂłALf[^̓X^[gtÕ^C~O̓͒lłBӖAX^[gtO͎アZbg݂Ȃ̂ł)
--
--@͂f[^1CLKOɃX^[gtO𗧂ĂĂB(X^[gtO͗ĂςȂł͓삵܂̂1CLKĂAɉĂ)
-- ܂AX^[gtO𗧂ĂA63CLKȓɍēxX^[gtO𗧂ĂȂłB(ЂƂ̓͒l8~8̃ubN̖Ɛ擪AŋʂĎgƂ)͂ł܂B
-- 듮삷\܂B(͂Ăf[^̍Ō̃^C~O(64CLK)ŃX^[gtO𗧂Ă邱ƁA܂A̓f[^̗L͈͂r؂ꂸɗ^邱Ƃ͉\ł)
--
-- 63CLKȓɃX^[gtO𗧂ĂꍇAUZbgsłΖȂ\łB̏ꍇA܂łɓ͂ꂽl̓Zbg܂B
--@
-- o͂64CLKďo͂܂B
-- 
-- c[ɂẮAIBRAMgpꍇ܂B
--
-- ԁ@F 65 clk (̓f[^ɒlꂽuԂAo͊Jn܂łCLK)
--
-- gݍ݃ubN
--
-- Ȃ
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ZIGZAGWRITE_PROCESS is
port(	I_SL_CLK			:	in		std_logic;							--NbNM
		I_SL_RST			:	in		std_logic;							--ZbgM(0:Zbg 1:ʏ)
		I_SL_START		:	in		std_logic;							--JnM()
		I_SLV11T0_DATA	:	in		std_logic_vector(11 downto 0);	--͐M(12bit)
		O_SL_START		:	out	std_logic;
		O_SLV11T0_DATA	:	out	std_logic_vector(11 downto 0)		--o͐M(12bit)
);
end ZIGZAGWRITE_PROCESS;

architecture Behavioral of ZIGZAGWRITE_PROCESS is

constant	con_start_flag_delay_int			:	integer:=65;
signal	sig_slv70t0_start_flag_shift_reg	:	std_logic_vector(70 downto 0);

signal	sig_slv11t0_data						:	std_logic_vector(11 downto 0);

--SRAM̍\
subtype	sub_type_12bit_data	is	std_logic_vector(11 downto 0);
type		ram0t63_12bit_data		is	array(0 to 64)	 of	sub_type_12bit_data;

signal	sig_ram0t63_12bit_data_a				:	ram0t63_12bit_data;--SRAM_A𐶐
signal	sig_ram0t63_12bit_data_b				:	ram0t63_12bit_data;--SRAM_B𐶐
signal	sig_int0t63_write_adress_counter	:	integer range 0 to 64 := 0;--SRAM֏݂sAhXJE^ǂݍ݃AhXƂ͔񓯊JEgȂ̂ŁB
signal	sig_int0t63_read_adress_counter	:	integer range 0 to 64 := 0;--SRAMǂݍ݂sAhXJE^݃AhXƂ͔񓯊JEgȂ̂ŁB

signal	sig_int0t63_zigzag_adress			:	integer range 0 to 64 := 0;--̂߁AWOUOl߂Ă񂱂ɂ

--ZIGZAG̃AhXԒn̍\
subtype	sub_type_zigzag_data	is	integer range	0 to	64;
type		zigzag_street			is	array(0 to 64)	 of	sub_type_zigzag_data;

--ZIGZAG_ROM̍\
constant	con_zigzag_adress_rom		:	zigzag_street	:=	(

 0, 1, 5, 6,14,15,27,28,
 2, 4, 7,13,16,26,29,42,
 3, 8,12,17,25,30,41,43,
 9,11,18,24,31,40,44,53,
10,19,23,32,39,45,52,54,
20,22,33,38,46,51,55,60,
21,34,37,47,50,56,59,61,
35,36,48,49,57,58,62,63,
64

);

--ǂSRAM֏ނ̃tOM
signal	sig_sl_ram_write_flag				:	std_logic	:=	'0';

begin


--ubNX^[gxM
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv70t0_start_flag_shift_reg(70 downto 1)	<=	sig_slv70t0_start_flag_shift_reg(69 downto 1)	&	I_SL_START;
			O_SL_START	<=	sig_slv70t0_start_flag_shift_reg(con_start_flag_delay_int);
	end if;
end process;


--STARTtOƂAǂRAMɕۑ邩l
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_int0t63_write_adress_counter=63)then--tOĂȂĂAǂ񂾃f[^oȂƂȂ̂ŁA]
--		if(I_SL_START='1' or sig_int0t63_write_adress_counter=63)then--tOĂȂĂAǂ񂾃f[^oȂƂȂ̂ŁA]
--		if(I_SL_START='1')then
			sig_sl_ram_write_flag	<=	not sig_sl_ram_write_flag;
		end if;
	end if;
end process;

--ZIGZAGݕ
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_slv11t0_data	<=	I_SLV11T0_DATA;
	end if;
end process;

--ZIGZAGݕ
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_ram_write_flag = '0')then
--			sig_ram0t63_12bit_data_a(sig_int0t63_write_adress_counter)	<=	I_SLV11T0_DATA;
			sig_ram0t63_12bit_data_a(sig_int0t63_write_adress_counter)	<=	sig_slv11t0_data;
		elsif(sig_sl_ram_write_flag = '1')then
--			sig_ram0t63_12bit_data_b(sig_int0t63_write_adress_counter)	<=	I_SLV11T0_DATA;
			sig_ram0t63_12bit_data_b(sig_int0t63_write_adress_counter)	<=	sig_slv11t0_data;
		end if;
	end if;
end process;

--write_adress_counter
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
--		if(I_SL_START	=	'1')then
		if(I_SL_START	=	'1' or I_SL_RST	=	'0')then--Zbg𓱓
			sig_int0t63_write_adress_counter	<=	0;
--		elsif(sig_int0t63_write_adress_counter = 63)then
--			sig_int0t63_write_adress_counter	<=	0;
		elsif(sig_int0t63_write_adress_counter = 64)then--64Ŏ~߂Ăǂ낤
			sig_int0t63_write_adress_counter	<=	64;
		else
			sig_int0t63_write_adress_counter	<=	sig_int0t63_write_adress_counter	+	1;
		end if;
	end if;
end process;

--ZIGZAG݂ꂽ̂[hĂ
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		if(sig_sl_ram_write_flag='1')then
--			O_SLV7T0_DATA	<=	sig_ram0t63_8bit_data_a(con_zigzag_adress_rom(sig_int0t63_read_adress_counter));
			O_SLV11T0_DATA	<=	sig_ram0t63_12bit_data_a(sig_int0t63_zigzag_adress);--INPUT̂ꂩ邩Agݍ킹H\΃XCXɂȂ炵
		elsif(sig_sl_ram_write_flag='0')then
--			O_SLV7T0_DATA	<=	sig_ram0t63_8bit_data_b(con_zigzag_adress_rom(sig_int0t63_read_adress_counter));
			O_SLV11T0_DATA	<=	sig_ram0t63_12bit_data_b(sig_int0t63_zigzag_adress);--INPUT̂ꂩ邩Agݍ킹H\΃XCXɂȂ炵
		end if;
	end if;
end process;

process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
		sig_int0t63_zigzag_adress	<=	con_zigzag_adress_rom(sig_int0t63_read_adress_counter);
	end if;
end process;

--read adress counter
process(I_SL_CLK)
begin
	if(I_SL_CLK'event and I_SL_CLK='1')then
--		if(sig_int0t63_write_adress_counter	=	63)then
--		if(sig_int0t63_write_adress_counter	=	62)then--̂߁A؂ւ1OɃAhXsĂ
		if(sig_int0t63_write_adress_counter	=	62	or	I_SL_RST	=	'0')then--̂߁A؂ւ1OɃAhXsĂ Zbg𓱓Ă݂
			sig_int0t63_read_adress_counter	<=	0;		
		elsif(sig_int0t63_read_adress_counter = 64)then--64Ŏ~߂Ăǂ낤@
--			sig_int0t63_read_adress_counter <=	63;
			sig_int0t63_read_adress_counter <=	64;
		else
			sig_int0t63_read_adress_counter	<=	sig_int0t63_read_adress_counter	+	1;	
		end if;
	end if;
end process;

end Behavioral;