----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:50:35 04/26/2010 
-- Design Name: 
-- Module Name:    BLOCK_RW - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity BLOCK_CONNECTOR_RW is
port(
		I_SL_CLK					:	in		std_logic;
		I_SL_RST					:	in		std_logic;
		I_SL_RW_FLAG			:	in		std_logic;
		I_SL_BLOCK_START		:	in		std_logic;
		I_SLV2T0_READ_LINE	:	in		std_logic_vector(2 downto 0);
		I_SL_DE					:	in		std_logic;--DEbAM̏ꏊǂɂ邩߂ĂȂ̂
		I_SLV7T0_DATA			:	in		std_logic_vector(7 downto 0);
		O_SLV7T0_DATA			:	out	std_logic_vector(7 downto 0)
);
end BLOCK_CONNECTOR_RW;

architecture Behavioral of BLOCK_CONNECTOR_RW is

component BRAM8_2560
port(
		clka	: IN	std_logic;
		wea	: IN	std_logic_VECTOR(0 downto 0);
		addra	: IN	std_logic_VECTOR(11 downto 0);
		dina	: IN	std_logic_VECTOR(7 downto 0);
		douta	: OUT	std_logic_VECTOR(7 downto 0)
);
end component;

signal	sig_slv7t0_data_1c_dff			:	std_logic_vector(7 downto 0):="00000000";
signal	sig_slv7t0_data_2c_dff			:	std_logic_vector(7 downto 0):="00000000";

signal	sig_slv7t0_enable_line			:	std_logic_vector(7 downto 0):="00000000";

signal	sig_slv63t0_wait_56clk_count			:	std_logic_vector(63 downto 0):="0000000000000000000000000000000000000000000000000000000000000000";

signal	sig_slv11t0_adress_line_1		:	std_logic_vector(11 downto 0):=(others=>'0');
signal	sig_slv11t0_adress_line_2		:	std_logic_vector(11 downto 0):=(others=>'0');
signal	sig_slv11t0_adress_line_3		:	std_logic_vector(11 downto 0):=(others=>'0');
signal	sig_slv11t0_adress_line_4		:	std_logic_vector(11 downto 0):=(others=>'0');
signal	sig_slv11t0_adress_line_5		:	std_logic_vector(11 downto 0):=(others=>'0');
signal	sig_slv11t0_adress_line_6		:	std_logic_vector(11 downto 0):=(others=>'0');
signal	sig_slv11t0_adress_line_7		:	std_logic_vector(11 downto 0):=(others=>'0');
signal	sig_slv11t0_adress_line_8		:	std_logic_vector(11 downto 0):=(others=>'0');

signal	sig_slv7t0_out_data1				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data2				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data3				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data4				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data5				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data6				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data7				:	std_logic_vector(7 downto 0);
signal	sig_slv7t0_out_data8				:	std_logic_vector(7 downto 0);


begin

--Write EnableĂԁAf[^҂
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			sig_slv7t0_data_1c_dff	<=	I_SLV7T0_DATA;
			sig_slv7t0_data_2c_dff	<=	sig_slv7t0_data_1c_dff;
		end if;
	end process;

--WriteEnable쐬ꏊA8CLKƂɏރCςĂ̂ŁACP̂Ō8CLKŏ񂾌A56CLK҂Ă邱ƂɂȂ
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SL_RW_FLAG='0')then--write
				if(sig_slv63t0_wait_56clk_count(7 downto 0)>"00000000")then
					sig_slv7t0_enable_line	<=	"00000001";--1CڂENABLEEEEȉlȊ
				elsif(sig_slv63t0_wait_56clk_count(15 downto 8)>"00000000")then
					sig_slv7t0_enable_line	<=	"00000010";
				elsif(sig_slv63t0_wait_56clk_count(23 downto 16)>"00000000")then
					sig_slv7t0_enable_line	<=	"00000100";
				elsif(sig_slv63t0_wait_56clk_count(31 downto 24)>"00000000")then
					sig_slv7t0_enable_line	<=	"00001000";
				elsif(sig_slv63t0_wait_56clk_count(39 downto 32)>"00000000")then
					sig_slv7t0_enable_line	<=	"00010000";
				elsif(sig_slv63t0_wait_56clk_count(47 downto 40)>"00000000")then
					sig_slv7t0_enable_line	<=	"00100000";
				elsif(sig_slv63t0_wait_56clk_count(55 downto 48)>"00000000")then
					sig_slv7t0_enable_line	<=	"01000000";
				elsif(sig_slv63t0_wait_56clk_count(63 downto 56)>"00000000")then
					sig_slv7t0_enable_line	<=	"10000000";
				else
					sig_slv7t0_enable_line	<=	"00000000";--[hł͂ȂAX^[gtOĂȂɏł͂ȂAAhXJEgAbvĂ͂ȂB
				end if;
			else
				sig_slv7t0_enable_line		<=	"00000000";--܂READ̂ƂĂ
			end if;
		end if;
	end process;

--56CLK҂鎞̃JEg

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SL_RW_FLAG='0')then--write
				if(I_SL_BLOCK_START='1')then--ubNX^[gĂAZbgEEEł͂
					sig_slv63t0_wait_56clk_count(63 downto 0)	<=	"0000000000000000000000000000000000000000000000000000000000000001";
				else
					sig_slv63t0_wait_56clk_count(63 downto 0)	<=	sig_slv63t0_wait_56clk_count(62 downto 0)	&	'0';--tO64CLKɖ߂Ă܂Ă͂Ȃ̂ŁA64CLKɂ̓tOׂ͂ăVtg
				end if;
			else
				sig_slv63t0_wait_56clk_count(63 downto 0)	<=	"0000000000000000000000000000000000000000000000000000000000000000";--WriteEnableďł܂Ȃ悤
			end if;
		end if;
	end process;

--EnableɂȂĂꏊ̃AhXJE^JEgAbvĂB[h̏ꍇ56CLKWAIT܂
	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SL_RW_FLAG='0')then
				if(sig_slv7t0_enable_line(0)='1')then
					sig_slv11t0_adress_line_1	<=	sig_slv11t0_adress_line_1 + 1;
				elsif(sig_slv7t0_enable_line(1)='1')then
					sig_slv11t0_adress_line_2	<=	sig_slv11t0_adress_line_2 + 1;
				elsif(sig_slv7t0_enable_line(2)='1')then
					sig_slv11t0_adress_line_3	<=	sig_slv11t0_adress_line_3 + 1;
				elsif(sig_slv7t0_enable_line(3)='1')then
					sig_slv11t0_adress_line_4	<=	sig_slv11t0_adress_line_4 + 1;
				elsif(sig_slv7t0_enable_line(4)='1')then
					sig_slv11t0_adress_line_5	<=	sig_slv11t0_adress_line_5 + 1;
				elsif(sig_slv7t0_enable_line(5)='1')then
					sig_slv11t0_adress_line_6	<=	sig_slv11t0_adress_line_6 + 1;
				elsif(sig_slv7t0_enable_line(6)='1')then
					sig_slv11t0_adress_line_7	<=	sig_slv11t0_adress_line_7 + 1;
				elsif(sig_slv7t0_enable_line(7)='1')then
					sig_slv11t0_adress_line_8	<=	sig_slv11t0_adress_line_8 + 1;
--				else
--					sig_slv11t0_adress_line_1	<=	"000000000000";
--					sig_slv11t0_adress_line_2	<=	"000000000000";
--					sig_slv11t0_adress_line_3	<=	"000000000000";
--					sig_slv11t0_adress_line_4	<=	"000000000000";
--					sig_slv11t0_adress_line_5	<=	"000000000000";
--					sig_slv11t0_adress_line_6	<=	"000000000000";
--					sig_slv11t0_adress_line_7	<=	"000000000000";
--					sig_slv11t0_adress_line_8	<=	"000000000000";
				end if;
			else--read
				if(I_SL_DE='1')then--ǂēȁ[fpM𒆂ɂĂAO͂ɂ邩EEExƂlȂƂ
					sig_slv11t0_adress_line_1	<=	sig_slv11t0_adress_line_1 + 1;
					sig_slv11t0_adress_line_2	<=	sig_slv11t0_adress_line_2 + 1;
					sig_slv11t0_adress_line_3	<=	sig_slv11t0_adress_line_3 + 1;
					sig_slv11t0_adress_line_4	<=	sig_slv11t0_adress_line_4 + 1;
					sig_slv11t0_adress_line_5	<=	sig_slv11t0_adress_line_5 + 1;
					sig_slv11t0_adress_line_6	<=	sig_slv11t0_adress_line_6 + 1;
					sig_slv11t0_adress_line_7	<=	sig_slv11t0_adress_line_7 + 1;
					sig_slv11t0_adress_line_8	<=	sig_slv11t0_adress_line_8 + 1;
				else
					sig_slv11t0_adress_line_1	<=	"000000000000";
					sig_slv11t0_adress_line_2	<=	"000000000000";
					sig_slv11t0_adress_line_3	<=	"000000000000";
					sig_slv11t0_adress_line_4	<=	"000000000000";
					sig_slv11t0_adress_line_5	<=	"000000000000";
					sig_slv11t0_adress_line_6	<=	"000000000000";
					sig_slv11t0_adress_line_7	<=	"000000000000";
					sig_slv11t0_adress_line_8	<=	"000000000000";
				end if;
			end if;
		end if;
	end process;



	line_1 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(0 downto 0),
		addra	=> sig_slv11t0_adress_line_1,
		dina	=> sig_slv7t0_data_2c_dff,
		douta	=> sig_slv7t0_out_data1
	);

	line_2 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(1 downto 1),
		addra	=> sig_slv11t0_adress_line_2,
		dina	=> sig_slv7t0_data_2c_dff,
		douta	=> sig_slv7t0_out_data2
	);

	line_3 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(2 downto 2),
		addra	=> sig_slv11t0_adress_line_3,
		dina	=> sig_slv7t0_data_2c_dff,
		douta	=> sig_slv7t0_out_data3
	);

	line_4 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(3 downto 3),
		addra	=> sig_slv11t0_adress_line_4,
		dina	=> sig_slv7t0_data_2c_dff,
		douta	=> sig_slv7t0_out_data4
	);

	line_5 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(4 downto 4),
		addra	=> sig_slv11t0_adress_line_5,
		dina	=> sig_slv7t0_data_2c_dff,
		douta	=> sig_slv7t0_out_data5
	);

	line_6 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(5 downto 5),
		addra	=> sig_slv11t0_adress_line_6,
		dina	=> sig_slv7t0_data_2c_dff,
		douta	=> sig_slv7t0_out_data6
	);

	line_7 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(6 downto 6),
		addra	=> sig_slv11t0_adress_line_7,
		dina	=> sig_slv7t0_data_2c_dff,
		douta	=> sig_slv7t0_out_data7
	);

	line_8 : BRAM8_2560	port map (
		clka	=>	I_SL_CLK,
		wea	=> sig_slv7t0_enable_line(7 downto 7),
		addra	=> sig_slv11t0_adress_line_8,
		dina	=> sig_slv7t0_data_2c_dff,
		douta	=> sig_slv7t0_out_data8
	);

	process(I_SL_CLK)
	begin
		if(I_SL_CLK'event and I_SL_CLK='1')then
			if(I_SLV2T0_READ_LINE="000")then--read line ͒xKvHHHH
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data1;
			elsif(I_SLV2T0_READ_LINE="001")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data2;
			elsif(I_SLV2T0_READ_LINE="010")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data3;
			elsif(I_SLV2T0_READ_LINE="011")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data4;
			elsif(I_SLV2T0_READ_LINE="100")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data5;
			elsif(I_SLV2T0_READ_LINE="101")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data6;
			elsif(I_SLV2T0_READ_LINE="110")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data7;
			elsif(I_SLV2T0_READ_LINE="111")then
				O_SLV7T0_DATA	<=	sig_slv7t0_out_data8;
			end if;
		end if;	
	end process;
	

end Behavioral;